%bcond_without bundled_shoutidjc

Summary:	Music DJing software
Name:		mixxx
Version:	2.4.0
Release:	%mkrel 5
Group:		Sound/Players
License:	GPLv2+
URL:		https://mixxx.org/
Source0:	https://github.com/mixxxdj/mixxx/archive/%{version}/%{name}-%{version}.tar.gz
Patch0:		desktop-file-qpa-platform-xcb.patch
BuildRequires:	cmake
BuildRequires:	ninja
BuildRequires:	icoutils
BuildRequires:	imagemagick
BuildRequires:	sed
BuildRequires:	ffmpeg-devel
BuildRequires:	ladspa-devel
BuildRequires:	hidapi-devel
BuildRequires:	mesaegl-devel
BuildRequires:	cmake(microsoft.gsl)
BuildRequires:	cmake(Qt5Keychain)
BuildRequires:	pkgconfig(Qt5Concurrent)
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5DBus)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Help)
BuildRequires:	pkgconfig(Qt5Network)
BuildRequires:	pkgconfig(Qt5OpenGL)
BuildRequires:	pkgconfig(Qt5PrintSupport)
BuildRequires:	pkgconfig(Qt5Qml)
BuildRequires:	pkgconfig(Qt5Script)
BuildRequires:	pkgconfig(Qt5ScriptTools)
BuildRequires:	pkgconfig(Qt5Sql)
BuildRequires:	pkgconfig(Qt5Svg)
BuildRequires:	pkgconfig(Qt5Test)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	pkgconfig(Qt5Xml)
BuildRequires:	pkgconfig(Qt5X11Extras)
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(audiofile)
BuildRequires:	pkgconfig(benchmark)
BuildRequires:	pkgconfig(djinterop)
BuildRequires:	pkgconfig(gtest)
BuildRequires:	pkgconfig(libchromaprint)
BuildRequires:	pkgconfig(libebur128)
BuildRequires:	pkgconfig(fftw3)
BuildRequires:	pkgconfig(jack)
BuildRequires:	pkgconfig(libgpod-1.0)
BuildRequires:	pkgconfig(libkeyfinder)
BuildRequires:	pkgconfig(libmodplug)
BuildRequires:	pkgconfig(lilv-0)
BuildRequires:	pkgconfig(lv2)
BuildRequires:	pkgconfig(mp4v2)
BuildRequires:	pkgconfig(ogg)
BuildRequires:	pkgconfig(openssl)
%if %{with bundled_shoutidjc}
Provides:	bundled(shout-idjc) = 2.4.1
%else
BuildRequires:	pkgconfig(shout-idjc) >= 2.4.6
%endif
BuildRequires:	pkgconfig(sndfile)
BuildRequires:	pkgconfig(soundtouch)
BuildRequires:	pkgconfig(vorbis)
BuildRequires:	pkgconfig(id3tag)
BuildRequires:	pkgconfig(taglib)
BuildRequires:	pkgconfig(mad)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(opusfile)
BuildRequires:	pkgconfig(libusb)
BuildRequires:	pkgconfig(portaudio-2.0)
BuildRequires:	pkgconfig(portmidi)
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	pkgconfig(rubberband)
BuildRequires:	pkgconfig(upower-glib)
BuildRequires:	pkgconfig(wavpack)

Requires:	qt5-database-plugin-sqlite
Recommends:	faad2
Recommends:	lv2

%description
Mixxx allows DJs to mix music live with a clean, simple interface.
Furthermore, Mixxx has a number of key features to help DJs in the mix:
Beat estimation, parallel visual displays, and support for various DJ
hardware controllers.

Mixxx can be controlled through the GUI using the mouse, or by
connecting MIDI devices to the computer. Commercial and custom build
MIDI controllers can be used. The mapping between functions and MIDI
controller values are done in text files.

%prep
%autosetup -p1

# drop bundled libs
rm -rf \
  lib/benchmark \
  lib/googletest \
  lib/hidapi \
  lib/keyfinder-install \
  lib/libebur128 \
%if ! %{with bundled_shoutidjc}
  lib/libshout-idjc \
%endif
  %nil

%build
%cmake -GNinja \
       -DKEYFINDER:BOOL=ON
%cmake_build

%install
%cmake_install

# not needed
rm -rf %{buildroot}%{_datadir}/pixmaps

# handle docs in files section
rm -rf %{buildroot}%{_datadir}/doc/mixxx/

%files
%license LICENSE COPYING
%doc README*
%doc res/Mixxx-Keyboard-Shortcuts.pdf
%{_bindir}/mixxx
%{_iconsdir}/hicolor/*/apps/*
%{_datadir}/mixxx/
%{_datadir}/applications/org.mixxx.Mixxx.desktop
%{_metainfodir}/org.mixxx.Mixxx.metainfo.xml
%{_udevrulesdir}/69-mixxx-usb-uaccess.rules


%changelog
* Sat Mar 23 2024 daviddavid <daviddavid> 2.4.0-5.mga10
+ Revision: 2051481
- rebuild for new portmidi 2.0.4

* Wed Feb 28 2024 daviddavid <daviddavid> 2.4.0-4.mga10
+ Revision: 2044834
- rebuild with fixed portmidi-217-20.mga10

* Tue Feb 27 2024 daviddavid <daviddavid> 2.4.0-3.mga10
+ Revision: 2044543
- add missing recommended dependency on lv2 (mga#32870#c14)

* Tue Feb 20 2024 daviddavid <daviddavid> 2.4.0-2.mga10
+ Revision: 2042593
- use system libdjinterop (now available on mageia)
- add fedora patch to use XWayland platform plugin (xcb) due to issues with Qt5 on Wayland

* Mon Feb 19 2024 daviddavid <daviddavid> 2.4.0-1.mga10
+ Revision: 2042555
- new version: 2.4.0

* Mon Aug 28 2023 daviddavid <daviddavid> 2.3.6-1.mga10
+ Revision: 1980504
- new version: 2.3.6 (fixes mga#32189)

* Mon May 22 2023 daviddavid <daviddavid> 2.3.5-1.mga9
+ Revision: 1957796
- new version: 2.3.5

* Sat Apr 22 2023 daviddavid <daviddavid> 2.3.4-1.mga9
+ Revision: 1954026
- new version: 2.3.4
- enable mp4v2 support

* Thu Dec 22 2022 wally <wally> 2.3.3-3.mga9
+ Revision: 1925790
- rebuild for protobuf 21.12

* Sun Nov 20 2022 wally <wally> 2.3.3-2.mga9
+ Revision: 1909274
- rebuild for flac 1.4.2

* Sun Oct 02 2022 papoteur <papoteur> 2.3.3-1.mga9
+ Revision: 1893809
- new version 2.3.3
- don't require libdjconsole

* Mon Apr 04 2022 umeabot <umeabot> 2.3.2-2.mga9
+ Revision: 1844026
- Mageia 9 Mass Rebuild
+ luigiwalser <luigiwalser>
- 2.3.2
+ mrambo3501 <mrambo3501>
- rebuild for ffmpeg 5.0
+ wally <wally>
- build with libshout-idjc as system version is too new and having some issues
- enable libkeyfinder support
- build with system shout-idjc

* Wed Dec 29 2021 wally <wally> 2.3.1-1.mga9
+ Revision: 1765207
- new version 2.3.1
- switch to cmake/ninja build
- rebuild for protobuf 3.19.1
+ luigiwalser <luigiwalser>
- rebuild for soundtouch

* Fri Apr 23 2021 daviddavid <daviddavid> 2.2.4-5.mga9
+ Revision: 1718222
- add patch to fix build with scons 4.1.0

* Fri Dec 18 2020 luigiwalser <luigiwalser> 2.2.4-4.mga8
+ Revision: 1660985
- rebuild for protobuf

* Thu Dec 17 2020 umeabot <umeabot> 2.2.4-3.mga8
+ Revision: 1659059
- Rebuild for new Qt5

* Mon Nov 30 2020 luigiwalser <luigiwalser> 2.2.4-2.mga8
+ Revision: 1650719
- rebuild for protobuf

* Tue Jul 14 2020 daviddavid <daviddavid> 2.2.4-1.mga8
+ Revision: 1606071
- new version: 2.2.4

* Sun Jun 28 2020 daviddavid <daviddavid> 2.2.3-4.mga8
+ Revision: 1600171
- rebuild for new protobuf 3.12.3

* Tue Feb 18 2020 umeabot <umeabot> 2.2.3-3.mga8
+ Revision: 1541399
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%setup_compile_flags

* Thu Dec 26 2019 tv <tv> 2.2.3-2.mga8
+ Revision: 1470189
- rebuild for new protobuf

* Fri Dec 13 2019 zezinho <zezinho> 2.2.3-1.mga8
+ Revision: 1466509
- new version

* Mon Sep 23 2019 daviddavid <daviddavid> 2.2.2-4.mga8
+ Revision: 1444745
- switch build to python3-scons

* Tue Sep 03 2019 daviddavid <daviddavid> 2.2.2-2.mga8
+ Revision: 1436663
- remove unneeded BR python2-devel

* Fri Aug 16 2019 zezinho <zezinho> 2.2.2-1.mga8
+ Revision: 1429418
- new bugfix version 2.2.2

* Wed Jun 19 2019 zezinho <zezinho> 2.2.1-1.mga7
+ Revision: 1400333
- new version fixing mga#24969

* Sun Mar 31 2019 daviddavid <daviddavid> 2.2.0-2.mga7
+ Revision: 1383606
- use python2-scons
- enable modplug, ffmpeg, qtkeychain and portmidi support
+ umeabot <umeabot>
- Qt5 Rebuild

* Tue Jan 01 2019 daviddavid <daviddavid> 2.2.0-1.mga7
+ Revision: 1348331
- new version: 2.2.0
- remove merged upstream patches

* Thu Nov 01 2018 daviddavid <daviddavid> 2.1.0-5.mga7
+ Revision: 1327103
- rebuild for fixed portmidi

* Mon Oct 22 2018 wally <wally> 2.1.0-4.mga7
+ Revision: 1323561
- add build support for aarch64

* Sun Sep 23 2018 umeabot <umeabot> 2.1.0-3.mga7
+ Revision: 1299563
- Mageia 7 Mass Rebuild

* Sat Jun 02 2018 daviddavid <daviddavid> 2.1.0-2.mga7
+ Revision: 1233601
- add upstream patch to fix build with new Qt5 >= 5.11.0 stack

* Wed May 02 2018 daviddavid <daviddavid> 2.1.0-1.mga7
+ Revision: 1224587
- new version: 2.1.0
- port to qt5
- remove unneeded patches
- install the upstream udev rule file
- install the upstream svg icon

* Sat Sep 16 2017 cjw <cjw> 2.0.0-7.mga7
+ Revision: 1154815
- patch1: remove -ffast-math workaround that breaks the build
  while this package is not built with -ffast-math

* Sun Oct 16 2016 pterjan <pterjan> 2.0.0-6.mga6
+ Revision: 1061104
- Also set machine type for install

* Sun Oct 16 2016 pterjan <pterjan> 2.0.0-5.mga6
+ Revision: 1061095
- Force machine type and use our flags

* Sun Feb 14 2016 luigiwalser <luigiwalser> 2.0.0-4.mga6
+ Revision: 960387
- rebuild for chromaprint

* Sat Jan 02 2016 zezinho <zezinho> 2.0.0-3.mga6
+ Revision: 918521
- remove flags that no longer exist
- do not use default debug build
- optimize portable only use portable optimization flags

* Sat Jan 02 2016 zezinho <zezinho> 2.0.0-2.mga6
+ Revision: 918359
- really fix vamp build

* Fri Jan 01 2016 zezinho <zezinho> 2.0.0-1.mga6
+ Revision: 917716
- add BR rubberband
- workaround for x86_64
- reordered BR
  vamp enabled as it is upstream recommended
- new version 2.0.0
- add opusfile
- add chromaprint

* Sat Aug 29 2015 cjw <cjw> 1.11.0-8.mga6
+ Revision: 870779
- rebuild with gcc 5

* Wed Oct 15 2014 umeabot <umeabot> 1.11.0-7.mga5
+ Revision: 748289
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.11.0-6.mga5
+ Revision: 682536
- Mageia 5 Mass Rebuild

* Fri Sep 05 2014 luigiwalser <luigiwalser> 1.11.0-5.mga5
+ Revision: 672249
- rebuild for protobuf

* Sat Jul 05 2014 pterjan <pterjan> 1.11.0-4.mga5
+ Revision: 643742
- Replace libusb*-devel BuildRequires by better ones

* Tue Dec 31 2013 dmorgan <dmorgan> 1.11.0-3.mga4
+ Revision: 563518
- Rebuild against current protobuf

* Sat Oct 19 2013 umeabot <umeabot> 1.11.0-2.mga4
+ Revision: 528593
- Mageia 4 Mass Rebuild

* Mon Jun 24 2013 dams <dams> 1.11.0-1.mga4
+ Revision: 446243
- update BR
- fix icon for better rendering
- new version 1.11.0

* Sat Jan 12 2013 umeabot <umeabot> 1.10.1-3.mga3
+ Revision: 360114
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Nov 25 2012 zezinho <zezinho> 1.10.1-2.mga3
+ Revision: 321851
- fix rpm group

* Thu Jun 28 2012 dams <dams> 1.10.1-1.mga3
+ Revision: 264686
- new version 1.10.1

* Mon Jan 02 2012 dams <dams> 1.10.0-1.mga2
+ Revision: 189638
- new version 1.10.0

* Sun Dec 18 2011 fwang <fwang> 1.9.2-2.mga2
+ Revision: 183665
- br qtwebkit

* Thu Nov 10 2011 dams <dams> 1.9.2-1.mga2
+ Revision: 166145
- new version 1.9.2
- clean specfile

* Thu Apr 07 2011 dams <dams> 1.9.0-2.mga1
+ Revision: 81673
- add 'qt4-database-plugin-sqlite' as a require

* Wed Apr 06 2011 dams <dams> 1.9.0-1.mga1
+ Revision: 81322
- clean, update 'BuildRequires', update scons options, update icon.png and update to 1.9.0
- clean, update 'BuildRequires', update scons options and update to 1.9.0
- clean, update 'BuildRequires' and update to 1.9.0
- clean, update 'BuildRequires' and update to 1.9.0
- Import, clean and update to 1.9.0
- Import, clean and update to 1.9.0
- imported package mixxx


* Sun Jan 24 2010 Jérôme Brenier <incubusss@mandriva.org> 1.7.2-1mdv2010.1
+ Revision: 495565
- new version 1.7.2
- fix x86_64 build

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - update to new version 1.7.1
    - spec file clean
    - update to new version 1.7.0

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild

  + Emmanuel Andry <eandry@mandriva.org>
    - drop patches
    - use desktop-file-utils

* Mon Jan 19 2009 Götz Waschk <waschk@mandriva.org> 1.6.1-3mdv2009.1
+ Revision: 331127
- rebuild for new libgpod

* Sat Jan 17 2009 Funda Wang <fwang@mandriva.org> 1.6.1-2mdv2009.1
+ Revision: 330740
- rediff djconsole patch
- rebuild

* Thu Oct 23 2008 Helio Chissini de Castro <helio@mandriva.com> 1.6.1-1mdv2009.1
+ Revision: 296764
- New upstream version

* Tue Jul 29 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.6.0-0.beta2.1mdv2009.0
+ Revision: 252544
- rebuild

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Fri Mar 07 2008 Adam Williamson <awilliamson@mandriva.org> 1.6.0-0.beta2.1mdv2008.1
+ Revision: 181218
- install .svg icon as well as .pngs
- adapt %%build and %%install to scons-based buildsystem, drop unnecessary substitutions
- update description
- update buildrequires for qt4 and scons-based buildsystem
- add optflags.patch (patches the build script to allow custom optflags, with thanks to misc for the python syntax help)
- add desktop.patch (fix up menu entry for MDV standards)
- add djconsole.patch (the build's test for libdjconsole doesn't seem to work for some reason, so disable the test and just assume it's present)
- drop djconsole-usb.patch (no longer needed, upstream uses pkg-config now)
- drop python-config.patch (no longer relevant)
- new license policy
- add conditionals to gracefully handle pre-release build
- new release 1.6.0 beta 2 (requested by Anne)

* Mon Feb 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.5.0.1-4mdv2008.1
+ Revision: 170982
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Mon Aug 20 2007 Oden Eriksson <oeriksson@mandriva.com> 1.5.0.1-3mdv2008.0
+ Revision: 67909
- rebuilt against new portaudio libs

* Sun Jun 24 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 1.5.0.1-2mdv2008.0
+ Revision: 43661
- fix bug #31551
- add scriplets

* Sat Jun 16 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 1.5.0.1-1mdv2008.0
+ Revision: 40422
- add buildrequires on usb-devel
- fix building on x86_64
- added missing buildrequires
- spec file clean

  + Helio Chissini de Castro <helio@mandriva.com>
    - Added patch to fix djconsole build against libusb
    - New and revamped mixxx for Mandriva
    - Added support for libdjconsole \o/.
    - Added support for scripting back ( bad python config test )
    - Removed ols debian like menu
    - Added proper desktop file and their official icons
    - Restored portaudio build.
      Lets's have some fun !!


* Tue Sep 05 2006 Emmanuel Andry <eandry@mandriva.org> 1.4.2-3mdv2007.0
- xdg menu
- fix buildrequires

* Wed Jun 22 2005 Tibor Pittich <Tibor.Pittich@mandriva.org> 1.4.2-2mdk
- include README.ALSA
- use mkrel

* Fri Jan 14 2005 Tibor Pittich <Tibor.Pittich@mandrake.org> 1.4.2-1mdk
- 1.4.2
- update configure parameters

* Thu Oct 14 2004 Tibor Pittich <Tibor.Pittich@mandrake.org> 1.4.1-1mdk
- 1.4.1

* Tue Oct 12 2004 Austin Acton <austin@mandrake.org> 1.4-1mdk
- 1.4

* Tue Sep 28 2004 Franck Villaume <fvill@freesurf.fr> 1.3.2-3mdk
- more BuildRequires

* Mon Sep 27 2004 Franck Villaume <fvill@freesurf.fr> 1.3.2-2mdk
- BuildRequires

* Tue Jul 27 2004 Tibor Pittich <Tibor.Pittich@mandrake.org> 1.3.2-1mdk
- 1.3.2
- added patch to allow buid with alsa support, enabled both jack and alsa
- cosmetics, added documentation

* Sun Jul 11 2004 Michael Scherer <misc@mandrake.org> 1.2.1-3mdk 
- rebuid for new gcc (patch #0)

* Mon Mar 22 2004 Austin Acton <austin@mandrake.org> 1.2.1-2mdk
- fix installation

* Mon Feb 16 2004 Austin Acton <austin@mandrake.org> 1.2.1-1mdk
- 1.2.1

* Tue Dec 30 2003 Austin Acton <austin@linux.ca> 1.2-1mdk
- 1.2
- link to local libs

* Mon Oct 06 2003 Austin Acton <aacton@yorku.ca> 1.0-1mdk
- 1.0
- delib buildrequires

